
define( [ require, '../../field', 'jquery-ui', 'components/farbtastic/src/farbtastic' ], function( require, FieldDefaultConstructor, ui ) {


	function hexToRgb( hex ) {
		var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
		return result ? [
			parseInt(result[1], 16),
			parseInt(result[2], 16),
			parseInt(result[3], 16)

		] : [0, 0, 0];
	}

	function rgbToHex( r, g, b) {
		return "#" + ((1 << 24) + (r << 16) + (g << 8) + b).toString(16).slice(1);
	}


	var FieldConstructor = function(name) {

		var self = this;

		this.name = name;
		this.domExpander = $("<div></div>");

		$("<div></div>").addClass('form-colorpicker').css({ 'float': 'left' }).farbtastic(function(color) {

			if( self.getElementExpanded( ) ) {
				var value = hexToRgb(color);

				self.getElementExpanded( ).value = [ value[ 0 ], value[ 1 ], value[ 2 ], self.getElementExpanded( ).value[ 3 ] ] ;
			}

		}).appendTo( this.domExpander );

		$("<div></div>").addClass('form-slider').css({ height: '180px', marginLeft: '20px', float: 'left' }).slider({ 

			orientation: "vertical",
		    min: 0,
		    max: 1,
		    step: 0.01,

		    start: function( event, ui ) {
		    	//event.preventDefault();
		    	event.stopPropagation();
		    },

		    slide: function( event, ui ) {

		    	self.getElementExpanded( ).value = [ self.getElementExpanded( ).value[ 0 ], self.getElementExpanded( ).value[ 1 ], self.getElementExpanded( ).value[ 2 ], ui.value ] ;
		   		event.stopPropagation( );
		    },

		    stop: function( event ) {

		    	event.preventDefault( );

		    }

		}).appendTo( this.domExpander );


		$("<div />").addClass('clear').appendTo( this.domExpander );
	};

	FieldConstructor.prototype = new FieldDefaultConstructor( );

	FieldConstructor.prototype.getOptions = function( fieldElement ) {
		
		return fieldElement.getOptions() || this.options.options
	};

	FieldConstructor.prototype.showExpander = function( fieldElement ) {

		this._showExpander( fieldElement );
		var value = fieldElement.value || [0, 0, 0, 1];
		$.farbtastic( this.domExpander.children( '.form-colorpicker' ) ).setColor( rgbToHex( value[0], value[1], value[2] ) );
		this.domExpander.children( '.form-slider' ).slider( 'value', value[ 3 ] );
	};


	return FieldConstructor;
});